// acetone, 2025
// I hate copyright of any kind. This is a public domain.
// Original source: http://git.community.i2p/acetone/i2pdtunnelwizard

#pragma once

#include "crow.h"
#include "crow/middlewares/utf-8.h"
#include "crow/middlewares/cookie_parser.h"
#include "languagehandlermiddleware.h"
#include "../tunnelconstructor.h"
#include "../notepad.h"

#include <string>

class HttpServer
{
public:
    HttpServer(const std::string& address, uint16_t port);
    void run();

private:
    void setup();

    crow::App<LanguageHandler, crow::CookieParser, crow::UTF8> app_;
    const std::string address_;
    const uint16_t port_;

    std::string start(Notepad::Lang lang);
    std::string extraPrivacyServer(Notepad::Lang lang, TunnelType type);
    std::string clientFinal(Notepad::Lang lang, TunnelType type, TunnelConstructor::BlindedType extraPrivacy, const std::string& currentUrl);
    std::string mainServer(Notepad::Lang lang, TunnelType type, TunnelConstructor::BlindedType blinded);
    std::string mainClient(Notepad::Lang lang, TunnelType type);
    std::string error(const std::string& text, Notepad::Lang lang, const std::string& backUrl, const std::string& currentUrl);
    std::string config(const std::string& generated, Notepad::Lang lang, bool comments, TunnelConstructor::BlindedType extraPrivacy, TunnelType type, const std::string& currentUrl);

    Notepad::Lang lang(const crow::request& req);
    std::pair<TunnelConstructor, bool> initTunnelConstructorViaUrlQuery(const crow::request& req, Notepad::Lang lang);
    std::string fullUrl(const crow::request& req);
};
